# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.  # noqa: E501

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ubiops.configuration import Configuration


class PipelineRequestDeploymentRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'pipeline_object': 'str',
        'deployment': 'str',
        'version': 'str'
    }

    attribute_map = {
        'id': 'id',
        'pipeline_object': 'pipeline_object',
        'deployment': 'deployment',
        'version': 'version'
    }

    def __init__(self, id=None, pipeline_object=None, deployment=None, version=None, local_vars_configuration=None):  # noqa: E501
        """PipelineRequestDeploymentRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._pipeline_object = None
        self._deployment = None
        self._version = None
        self.discriminator = None

        self.id = id
        self.pipeline_object = pipeline_object
        self.deployment = deployment
        self.version = version

    @property
    def id(self):
        """Gets the id of this PipelineRequestDeploymentRequest.  # noqa: E501


        :return: The id of this PipelineRequestDeploymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PipelineRequestDeploymentRequest.


        :param id: The id of this PipelineRequestDeploymentRequest.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                id is not None and not isinstance(id, str)):
            raise ValueError("Parameter `id` must be a string")  # noqa: E501

        self._id = id

    @property
    def pipeline_object(self):
        """Gets the pipeline_object of this PipelineRequestDeploymentRequest.  # noqa: E501


        :return: The pipeline_object of this PipelineRequestDeploymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._pipeline_object

    @pipeline_object.setter
    def pipeline_object(self, pipeline_object):
        """Sets the pipeline_object of this PipelineRequestDeploymentRequest.


        :param pipeline_object: The pipeline_object of this PipelineRequestDeploymentRequest.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                pipeline_object is not None and not isinstance(pipeline_object, str)):
            raise ValueError("Parameter `pipeline_object` must be a string")  # noqa: E501

        if (self.local_vars_configuration.client_side_validation and
                pipeline_object is not None and len(pipeline_object) < 1):
            raise ValueError("Invalid value for `pipeline_object`, length must be greater than or equal to `1`")  # noqa: E501

        self._pipeline_object = pipeline_object

    @property
    def deployment(self):
        """Gets the deployment of this PipelineRequestDeploymentRequest.  # noqa: E501


        :return: The deployment of this PipelineRequestDeploymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._deployment

    @deployment.setter
    def deployment(self, deployment):
        """Sets the deployment of this PipelineRequestDeploymentRequest.


        :param deployment: The deployment of this PipelineRequestDeploymentRequest.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                deployment is not None and not isinstance(deployment, str)):
            raise ValueError("Parameter `deployment` must be a string")  # noqa: E501

        if (self.local_vars_configuration.client_side_validation and
                deployment is not None and len(deployment) < 1):
            raise ValueError("Invalid value for `deployment`, length must be greater than or equal to `1`")  # noqa: E501

        self._deployment = deployment

    @property
    def version(self):
        """Gets the version of this PipelineRequestDeploymentRequest.  # noqa: E501


        :return: The version of this PipelineRequestDeploymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PipelineRequestDeploymentRequest.


        :param version: The version of this PipelineRequestDeploymentRequest.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                version is not None and not isinstance(version, str)):
            raise ValueError("Parameter `version` must be a string")  # noqa: E501

        if (self.local_vars_configuration.client_side_validation and
                version is not None and len(version) < 1):
            raise ValueError("Invalid value for `version`, length must be greater than or equal to `1`")  # noqa: E501

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PipelineRequestDeploymentRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PipelineRequestDeploymentRequest):
            return True

        return self.to_dict() != other.to_dict()
